<?php
//
// +---------------------------------------------------------------------------+
// | Universal Plugin 1.0 for Geeklog - The Ultimate Weblog                    |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// | This file does two things: 1) it implements the necessary Geeklog Plugin  |
// | API method and 2) implements all the common code needed by the advt   |
// | PHP files.                                                                |
// |                                                                           |
// | This is a generic functions.inc for Geeklog 1.3.6.  Edit this file with   |
// | your favorite editor and replace every instance of advt with the name |
// | of your plugin.  You will then have a skeletal working functions.inc.     |
// | See documentation to fill in API implementations you man need.            |
// | You must also fill in the two arrays in the uninstall routine for it to   |
// | work properly.                                                            |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Author:                                                                   |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    twillett@users.sourceforge.net           |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

/**
* This is the generic functions.inc for the Universal Plugin Toolkit for Geeklog.
* You need to change all instances of advt with the name of your plugin.
*/

/**
* Language file Include
*/
$langfile = $_CONF['path'] . '/advt/language/' . $_CONF['language'] . '.php';
if (file_exists ($langfile)) {
    include_once ($langfile);
}
else {
    include_once ($_CONF['path'] . 'plugins/advt/language/english.php');
}

       $_ADVT_plugin_name='advt';

/*
* Include advt config file
*/
require_once ($_CONF['path'] . 'plugins/advt/config.php');

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

/**
* Returns the items for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
* Universal Plugin:  Uncomment and fill in variables;
* 
* @return    array   Associative array of menu items to be added to menu
*
*/
function plugin_getmenuitems_advt()
{
    global $_CONF, $LANG_ADVT;

    $menulabel[$LANG_ADVT['classifieds']];
    $menuitems[$LANG_ADVT['menuitem']] = $_CONF['site_url'] . "/advt/index.php";
    
//        $menuitems = array(); 
//        if (SEC_hasRights('advt.view')) { 
//            $menuitems["$menulabel"] = $menurul; 
//        } 
    return $menuitems; 
}

/**
* Check to see if this Plugin uses comments
*
* Geeklog is checking to see if this plugin supports comments, tell it no!
* NOTE: to support comments you must use the same date/time based ID for your
* widget.  In other words, to make primary keys for your plugin you should call
* makesid().  Comments are keyed off of that...it is a limitation on how geeklog
* does comments.
*
* @return   boolean true or false
*
*/
function plugin_commentsupport_advt() 
{
    return false;
}

/**
* Shows the statistics for the plugin on stats.php.  If
* $showsitestats is 1 then we are to only print the overall stats in the 'site
* statistics' box otherwise we show the detailed stats for the plugin
*
* Universal Plugin:  Modify/uncomment use it
*
* @param    int showsitestate   Flag to let us know which stats to get
* @return   string  returns formatted HTML to insert in stats page
*
*/
function plugin_showstats_advt($showsitestats) 
{
//    global $_CONF, $_TABLES;

//    $stat_templates = new Template($_CONF['path_layout'] . 'stats');
//    $stat_templates->set_file(array('itemstats'=>'itemstatistics.thtml',
//                            'statrow'=>'singlestat.thtml'));
        $retval='';
//    if ($showsitestats == 1) {
        // This shows in the summary box
//        $total_pages=DB_count($_TABLES['table1']);     // Fill this with count for summary
//        $summary_label = "advt";                   // Fill this with label displayed
        
//        $retval = "<table border = '0' width='100%' cellspacing='0' cellpadding='0'>";
//        $retval .= "<tr><td>$summary_label</td>";
//        $retval .= "<td align='right'>" . $total_pages . "&nbsp;&nbsp </td></tr></table>";
//    } else {
        // This fills the top the box  Use the following as a template
//        $result = DB_query("SELECT id, title, hits from {$_TABLES['table1'] WHERE hits > 0 ORDER BY hits desc LIMIT 10");
//        $nrows  = DB_numRows($result);
//        $retval .= COM_startBlock("Top Ten Static Pages");
//        if ($nrows > 0) {
//            $stat_templates->set_var('item_label',"Page Title");
//            $stat_templates->set_var('stat_name',"Hits");
//            for ($i = 0; $i < $nrows; $i++) {
//                $A = DB_fetchArray($result);
//                $stat_templates->set_var('item_url', $_CONF['site_url'] . '/advt/index.php?item=' . $A['id']);
//                $stat_templates->set_var('item_text', $A['title']);
//                $stat_templates->set_var('item_stat', $A['hits']);
//                $stat_templates->parse('stat_row','statrow',true); 
//            }
//            $stat_templates->parse('output','itemstats');
//            $retval .= $stat_templates->finish($stat_templates->get_var('output'));
//        } else {
//            $retval .= 'It appears that there are no advts on this site or no one has ever viewed them.';
//        }	
//        $retval .= COM_endBlock();
//    }
    return $retval;
}

/**
* This will put an option for the plugin in the command and control block on moderation.php
*
* Add the plugin name, icon and link to the command and control block in moderation.php
*
* @return   array   Array containing (plugin name, admin url, url of plugin icon)
*
*/
function plugin_cclabel_advt() 
{
    global $_CONF;

    return array('advt',$_CONF['site_admin_url'] . '/plugins/advt/index.php',$_CONF['site_url'] . '/advt/images/advt.gif');
}

/**
* Returns the administrative option for this plugin
*
* Adds the plugin to the Admin menu
*
* Universal Plugin:  Modify/Uncomment use it
*
* @return   array   Array containing (plugin name, plugin admin url, # of items in plugin or '')
*
*/
function plugin_getadminoption_advt() 
{
    global $_CONF, $LANG_ADVT;

    if (SEC_hasRights('advt.admin')) {
        return array($LANG_ADVT['classifieds'], $_CONF['site_admin_url'] . '/plugins/advt/index.php',0);
    }
}

/**
* Returns the user option for this plugin
*
* Adds the plugin to the user menu
*
* Universal Plugin:  modify/uncomment use it
*
* @return   array   Array containing (plugin name, plugin user url, 0)
*
*/
 function plugin_getuseroption_advt() 
 {
    global $_CONF, $LANG_ADVT;

    if (SEC_hasRights('advt.edit,advt.view','OR'))  {
        return array($LANG_ADVT['classifieds'], $_CONF['site_url'] . '/advt/account.php', 0);
    }
}

/**
* Removes the datastructures for this plugin from the Geeklog database.
* This routine will get called from the Plugin install program if user select De-Install or if Delete is used in the Plugin Editor.
* The Plugin Installer will also call this routine upon and install error to remove anything it has created.
* The Plugin installer will pass the optional parameter which will then double check that plugin has first been disabled. 
* 
* For this plugin, this routine will also remove the Block definition.
* 
* Returns True if all Plugin related data is removed without error
*
* @param    string   $installCheck     Defult is blank but if set, check if plugin is disabled first
* 
* @return   boolean True if successful false otherwise
*
*/  
function plugin_uninstall_advt($installCheck='')
{
    global $_TABLES, $LANG_ADVT;

    // The advts need to be changed to the name of your plugin
    //
    $pi_name='advt';
	$FEATURES = array ( 'advt.admin', 'advt.edit');
	$TABLES = array ('ad_ads','ad_category','ad_notice','ad_photo','ad_uinfo');
    
    // Check and see if plugin is still enabled - if so display warning and exit
    if ($installCheck != '' && DB_getItem($_TABLES['plugins'],'pi_enabled', 'pi_name = "' .$pi_name. '"')) {
	    COM_errorLog("Plugin is installed and enabled. Disable first if you want to de-install it",1);
		echo COM_startBlock($LANG_ADVT['warning']);
		echo $LANG_ADVT['enabled'];
		echo COM_endBlock();
		echo $display;
		return false;
		exit;
	}
    	
	// Ok to proceed and delete plugin

    // Unregister the plugin with Geeklog
    COM_errorLog('Attempting to unregister the advt plugin from Geeklog',1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = 'advt'",1);

    // Drop advt tables
    foreach($TABLES as $table) {
        $t = $_TABLES["$table"];
        COM_errorLog("Removing Table $t",1);
        DB_query("DROP TABLE $t",1);
    }

    // Remove Security for this plugin
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = '{$pi_name}_gid'");
    
    COM_errorLog("Removing $pi_name Admin Group", 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = '{$pi_name}_gid'");
    COM_errorLog("Removing root users from admin of $pi_name");
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);
    
    // Remove all the associated features -- access rights
    foreach ($FEATURES as $feature) {
        COM_errorLog("Removing $feature feature and rights to it",1);
        $feat_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = '$feature'");
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feat_id",1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $feat_id",1);
    }
        
    COM_errorLog('...success',1);
    return true;
}

	function displayHeader( $title = "" )
	{
		global $ADVT_NAME, $PAGE_BG_COLOR, $PAGE_BG_IMAGE;
		echo "\n<html>\n";
		echo "<head>\n";
		echo "<title>$title</title>\n";
		echo "</head>\n\n";
		echo "<body bgcolor=\"$PAGE_BG_COLOR\" background=\"$PAGE_BG_IMAGE\">\n\n";
		echo "<center><h2>$ADVT_NAME</h2></center>\n";
	}

	function findTotalAds( $id )
	{
	global $_TABLES;
		$time = time();
		$result = mysql_query( "SELECT root_id FROM {$_TABLES['ad_category']} WHERE papa_id=$id" ) or error( mysql_error() );
		if( mysql_num_rows( $result ) == 0 )
			$totalAds += mysql_num_rows( mysql_query( "SELECT cat_id FROM {$_TABLES['ad_ads']} WHERE cat_id=$id AND exp_date>$time" ) );
		else
			while( $row = mysql_fetch_array( $result ) )
				$totalAds += findTotalAds( $row['root_id'] );
		return $totalAds;
	}

	function displayFooter()
	{
	global $_CONF, $IMAGE_DIR;

		echo "<p align=\"center\"><img src=\"$IMAGE_DIR/zClassified.png\" width=\"100\" height=\"40\" border=\"0\" alt=\"Powered by zClassified\"></p>\n";
		echo "<p align=\"center\"><small>All Rights Reserved by XGRA.COM 2001.</small></p>\n\n";
		echo "</body>\n";
		echo "</html>\n";
		exit;
	}

	function displayLocationNoLink( $id )
	{
	global $_TABLES;
		$result = mysql_query( "SELECT cat_name, root_id, papa_id FROM {$_TABLES['ad_category']} WHERE root_id=$id" ) or error( mysql_error() );
		$row = mysql_fetch_array( $result );
		if( $row['papa_id'] == 0 ) $location .= $row['cat_name'];
		else
		{
			$location .= displayLocationNoLink( $row['papa_id'] );
			$location .= " :: {$row['cat_name']}";
		}
		return "$location";
	}

	function displayLocation( $id )
	{
		global $cat, $PHP_SELF, $_TABLES;
//		$result = mysql_query( "SELECT cat_name, root_id, papa_id FROM {$_TABLES['ad_category']} WHERE root_id=$id" ) or error( mysql_error() );
		$result = mysql_query( "SELECT cat_name, root_id, papa_id FROM {$_TABLES['ad_category']} WHERE root_id=$id");
		$row = mysql_fetch_array( $result );
		if( $row['papa_id'] == 0 )
		{
			if( $row['root_id'] == $cat ) $location = "<a href=\"$PHP_SELF\">Home</a> :: {$row['cat_name']}";
			else $location = "<a href=\"$PHP_SELF\">Home</a> :: <a href=\"$PHP_SELF?cat={$row['root_id']}\">{$row['cat_name']}</a>";
		}
		else
		{
			if( $row['root_id'] == $cat ) $location = " &gt; {$row['cat_name']}";
			else $location = " &gt; <a href=\"$PHP_SELF?cat={$row['root_id']}\">{$row['cat_name']}</a>";
			displayLocation( $row['papa_id'] );
		}
		echo "      <b>$location</b>\n";
	}

	function displayMoreCat()
	{
		global $cat, $PHP_SELF, $_TABLES;
		$currentId = findCatRoot( $cat );
		$result = mysql_query( "SELECT cat_name, root_id FROM {$_TABLES['ad_category']} WHERE papa_id='' AND root_id!=$currentId" ) or error( mysql_error() );
		echo "<p>&nbsp;</p>\n";
		echo "<div align=\"center\">\n";
		echo "  <center>\n";
		echo "  <table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">\n";
		echo "    <tr>\n";
		echo "      <td><b>More categories &gt;</b><br>\n";
		while( $row = mysql_fetch_array( $result ) )
			echo "      <li><a href=\"$PHP_SELF?cat={$row['root_id']}\">{$row['cat_name']}</a></li>\n";
		echo "      </td>\n";
		echo "    </tr>\n";
		echo "  </table>\n";
		echo "  </center>\n";
		echo "</div>\n";
	}

	function findCatRoot( $id )
	{
		global $_TABLES;
		$result = mysql_query( "SELECT root_id, papa_id FROM {$_TABLES['ad_category']} WHERE root_id=$id" ) or error( mysql_error() );
		$row = mysql_fetch_array( $result );
		if( mysql_num_rows( $result ) != 0 ) findCatRoot( $row['papa_id'] );
		return $row['root_id'];
	}

	function sentMail( $from, $to, $subject, $body )
	{
		$headers  = "MIME-Version: 1.0\r\n";
		$headers .= "Content-type: text/html; charset=ios-8859-1\r\n";
		$headers .= "From: {$from}\r\n";
		$result = @mail( $to, $subject, $body, $headers );
		if( $result ) return true;
		else return false;
	}

	function currentLocation( $id )
	{
		global $_TABLES;
		$result = mysql_query( "SELECT cat_name, root_id, papa_id FROM {$_TABLES['ad_category']} WHERE root_id=$id" ) or error( mysql_error() );
		$row = mysql_fetch_array( $result );
		if( $row['papa_id'] == 0 )
			$location = "<a href=\"index.php\">Home</a> :: <a href=\"index.php?cat={$row['root_id']}\">{$row['cat_name']}</a>";
		else
		{
			$location = " &gt; <a href=\"index.php?cat={$row['root_id']}\">{$row['cat_name']}</a>";
			currentLocation( $row['papa_id'] );
		}
		echo "      <b>$location</b>\n";
	}

	function displayCat( $id )
	{
		global $_TABLES;
		//display small cat root
		$result = mysql_query( "SELECT cat_name, root_id, papa_id FROM {$_TABLES['ad_category']} WHERE root_id=$id" ) or error( mysql_error() );
		$row = mysql_fetch_array( $result );
		if( $row['papa_id'] == 0 )
			$location = "Category : <a href=\"index.php?cat={$row['root_id']}\">{$row['cat_name']}</a>";
		else
		{
			$location = " &gt; <a href=\"index.php?cat={$row['root_id']}\">{$row['cat_name']}</a>";
			displayCat( $row['papa_id'] );
		}
		echo "            <small>$location</small>\n";
	}

if ($_CONF_ADVT['$autothumbnail'] == 1 )
{
function makeThumb( $scrFile, $dstFile, $dstW=120, $dstH=100 )
	{
		global $_CONF;
		$im = ImageCreateFromJPEG( $scrFile );
		$srcW = ImageSX( $im );
		$srcH = ImageSY( $im );
		$ni = ImageCreateTrueColor( $dstW, $dstH );
		ImageCopyResized( $ni, $im, 0, 0, 0, 0, $dstW, $dstH, $srcW, $srcH );
		ImageJPEG( $ni, $dstFile );
	}
}
?>